﻿//////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2006 Michael Jentsch
// All rights reserved
//////////////////////////////////////////////////////////////////////////////////////
view.caption = strTitle;
contentArea.contentFlags = gddContentFlagHaveDetails;
contentArea.maxContentItems = 100;

// TODO über die Options ff.gif, ie.gif, op.gif
var itemImage = new Array ();
var itemImageHeight = 40;  // the image's height in pixels
var itemImageWidth  = 60;  // the image's height in pixels

plugin.onShowOptionsDlg = ShowOptions;

var http = new XMLHttpRequest();

var titles = new Array();

var shell = new ActiveXObject("WScript.Shell");

var thumbPos = 0;

//////////////////////////////////////////////////////////////////////////////////////
// Options Dialog
//////////////////////////////////////////////////////////////////////////////////////
function ShowOptions(wnd) 
{
  
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Bookmarks", 10, 10, 380, 25);
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", "URL:", 10, 40, 90, 25);
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Title:", 10, 70, 90, 25);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "url_edit", "", 50, 35, 300, 25);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "title_edit", "", 50, 65, 300, 25);
  wnd.AddControl(gddWndCtrlClassList, 0, "url_list", GetUrls(), 10, 100, 340, 150);
  var add_btn    = wnd.AddControl(gddWndCtrlClassButton, 0, "", "Add", 360, 35, 70, 25);
  var remove_btn = wnd.AddControl(gddWndCtrlClassButton, 0, "", "Remove", 360, 100, 70, 25);
  var up_btn = wnd.AddControl(gddWndCtrlClassButton, 0, "", "Up", 360, 140, 70, 25);
  var down_btn = wnd.AddControl(gddWndCtrlClassButton, 0, "", "Down", 360, 165, 70, 25);

  wnd.onClose          = OptionsDlgClosed;
  add_btn.onClicked    = AddButtonClicked;
  remove_btn.onClicked = RemoveButtonClicked;
  up_btn.onClicked     = UpButtonClicked;
  down_btn.onClicked   = DownButtonClicked;
}

function OptionsDlgClosed(wnd, code) 
{
  if (code == gddIdOK) 
  {
    var list = wnd.GetControl("url_list");
    var urls;
    if (list.text == null)
      urls = new Array();
    else
      urls = new VBArray(list.text).toArray();
    PutUrls(urls);
    contentArea.removeAllContentItems(); // since some may have been deleted
    InitImageItems();
    RefreshDisplay(); // to refresh items and add again
    thumbPos = 0;
    FetchThumbshots();
  } else {
    var edit  = wnd.GetControl("url_edit");
    var title = wnd.GetControl("title_edit");
    var str = edit.value + title.value;
  }
}

function PutUrls(urls) {
  options.removeAll();
  for (var i = 0; i < urls.length; ++i)
  {
    options("url_" + i) = urls[i];
    options(urls[i]) = titles[urls[i]];
  }
}

function GetUrls() {
  var arr = new Array();
  var url = " ";
  for (var i = 0; url != undefined; ++i) {
    url = options("url_" + i);
    if (url != undefined)
    {
      titles[url] = options(url); 
      arr.push(url);
    }
  }
  return arr;
}

function AddButtonClicked(wnd, ctrl) 
{
  var edit  = wnd.GetControl("url_edit");
  var title = wnd.GetControl("title_edit");
  var url = TrimString(edit.value);
  if (url != "") {
    if (url.substring(0, 7) != "http://")
      url = "http://" + url;
    var list = wnd.GetControl("url_list");
    var urls = new VBArray(list.text).toArray();
    urls.push(url);
    titles[url] = TrimString(title.value);
    list.text = urls;
    edit.value = "";
    title.value = "";
  }
}

function RemoveButtonClicked(wnd, ctrl) 
{
  var list = wnd.GetControl("url_list");
  var url_to_remove = list.value;
  var urls = new VBArray(list.text).toArray();
  for (var i = 0; i < urls.length; ++i) {
    if (urls[i] == url_to_remove) {
      urls.splice(i, 1);
      break;
    }
  }
  list.text = urls;
  if (i < urls.length)
    list.value = urls[i];  // select next one in list
}

function UpButtonClicked(wnd, ctrl) 
{
  var list = wnd.GetControl("url_list");
  var url_to_up = list.value;
  var urls = new VBArray(list.text).toArray();
  var tmp;
  for (var i = 1; i < urls.length; ++i) {
    if (urls[i] == url_to_up) {
      tmp = urls[i];
      urls[i] = urls[i-1];
      urls[i-1] = tmp;
      break;
    }
  }
  list.text = urls;
  if (i < urls.length)
    list.value = urls[i];  // select next one in list
}

function DownButtonClicked(wnd, ctrl) 
{
  var list = wnd.GetControl("url_list");
  var url_to_down = list.value;
  var urls = new VBArray(list.text).toArray();
  var tmp;
  for (var i = 0; i < urls.length-1; ++i) {
    if (urls[i] == url_to_down) {
      tmp = urls[i];
      urls[i] = urls[i+1];
      urls[i+1] = tmp;
      break;
    }
  }
  list.text = urls;
  if (i < urls.length)
    list.value = urls[i];  // select next one in list
}

function TrimString(str) {
  str = str.replace( /^\s+/g, "" );   // strip leading whitespaces
  return str.replace( /\s+$/g, "" );  // strip trailing whitespaces
}

//////////////////////////////////////////////////////////////////////////////////////


if (options("url_0") == undefined)
{
  options("url_0") = "http://www.google.de/";
  options("http://www.google.de/") = "Google";
}

InitImageItems();
RefreshDisplay();
FetchThumbshots();

function URLEncode(plaintext)
{
	var SAFECHARS = "0123456789" +		// Numeric
			"ABCDEFGHIJKLMNOPQRSTUVWXYZ" +	// Alphabetic
			"abcdefghijklmnopqrstuvwxyz" +
					"-_.!~*'()";	// RFC2396 Mark characters
	var HEX = "0123456789ABCDEF";

	var encoded = "";
	for (var i = 0; i < plaintext.length; i++ ) {
		var ch = plaintext.charAt(i);
	    if (ch == " ") {
		    encoded += "+";				// x-www-urlencoded, rather than %20
		} else if (SAFECHARS.indexOf(ch) != -1) {
		    encoded += ch;
		} else {
		    var charCode = ch.charCodeAt(0);
			if (charCode <= 255) {
				encoded += "%";
				encoded += HEX.charAt((charCode >> 4) & 0xF);
				encoded += HEX.charAt(charCode & 0xF);
			}
		}
	} 
	return encoded;
}

function InitImageItems ()
{
  var urls = GetUrls();
  for (var i = 0; i < urls.length; ++i)
  {
    itemImage[i] = graphics.loadImage("ff.gif");
  }
}

function ClearDisplay() {
  // clear display and add new items with latest information
  contentArea.removeAllContentItems();
}

function RefreshDisplay() {
  // clear display and add new items with latest information
  contentArea.removeAllContentItems();
  var urls = GetUrls();
  for (var i =urls.length-1; i >= 0; i--)
  {
    var item = new ContentItem();
    item.heading = i; 
    item.tooltip = urls[i];
    item.source  = urls[i];
    item.snippet = strItemSnippet;
    item.image = itemImage[i];
    item.flags = gddContentItemFlagNoRemove;
    item.onDrawItem = DrawItem; 
    item.onGetHeight = GetItemHeight;  
    item.onDetailsView = DetailsView;
    item.open_command = urls[i];
    contentArea.addContentItem(item, gddItemDisplayInSidebar);
  }
}

function OnData() 
{
    if (http.readyState == 4)
    {
      try {
        itemImage[thumbPos] = utils.loadImage(http.responseStream); 
      } catch (e) { /* TODO */ }
      thumbPos ++;
      FetchThumbshots();
    }
}

function FetchThumbshots ()
{
  var urls = GetUrls();
  var thumbUrl;
  var i = thumbPos; 
  if (i < urls.length)
  {
    http = new XMLHttpRequest();
    http.onreadystatechange = OnData;
    var encodedUrl = URLEncode(urls[i]);
    thumbUrl = "http://www.m-software.de/screenshot/Screenshot.png?url=" + encodedUrl + "&type=jpg&scale=10";
    // http://www.m-software.de/screenshot/Screenshot.png?url=http%3A%2F%2Fheise.de&scale=6
    // shell.popup("Popup",0,thumbUrl);
    http.open("GET", thumbUrl, true);
    http.send();
  } else {
    RefreshDisplay();
  }  
}

function DetailsView (item)
{
	shell.run (item.source);
}

// Called to find out the height of each content item
function GetItemHeight(item, target, graphics, width) {
  return itemImageHeight + 2;
}

// Called to draw each content item
function DrawItem(item, target, graphics, x, y, width, height) {
  graphics.DrawImage(x, y, itemImageWidth, itemImageHeight, itemImage[item.heading], 100);
  var text = options(item.source) + " ";
  var textx      = x + 2 + itemImageWidth;
  var texty      = y + 2;
  var textwidth  = width - itemImageWidth - 4;
  var textheight = itemImageHeight + 2
  var th = graphics.GetTextHeight (text, textwidth, 0, gddFontNormal);
  var tw = graphics.GetTextWidth  (item.source, 0, gddFontNormal);

  graphics.DrawText(textx,  texty, textwidth, textheight, item.source, "#0000FF", gddTextFlagSingleLine, gddFontNormal);
  graphics.DrawLine(textx, texty+th, tw+textx, texty+th,"#0000FF");
  graphics.DrawText(textx, texty + th, textwidth, textheight - th, text, gddColorNormalText, gddTextFlagWordBreak, gddFontSnippet);
}
